using System;
using Dapfor.Net.Data;

namespace Dapfor.Net.Grid.Tutorial.BusinessData.CAC40
{
    public class Market
    {
        public const string FieldMarketName = "MarketName";

        private readonly DateTime _closeTime;
        private readonly string _name;
        private readonly DateTime _openTime;
        private bool _marketState;

        public Market(string name, DateTime openTime, DateTime closeTime, bool marketState)
        {
            _name = name;
            _openTime = openTime;
            _closeTime = closeTime;
            _marketState = marketState;
        }

        [Field(FieldMarketName)]
        public string Name
        {
            get { return _name; }
        }

        public DateTime OpenTime
        {
            get { return _openTime; }
        }

        public DateTime CloseTime
        {
            get { return _closeTime; }
        }

        public bool MarketState
        {
            get { return _marketState; }
            set { _marketState = value; }
        }
    }
}