using System;
using System.ComponentModel;

namespace Dapfor.Net.Grid.Tutorial.BusinessData.Currencies
{
    /// <summary>
    /// TypeDesctiptor provider. Should be declared in the CurrencyRate class as [TypeDescriptionProvider(typeof(CurrencyRateTypeDescriptorProvider))]
    /// </summary>
    internal class CurrencyRateTypeDescriptorProvider : TypeDescriptionProvider
    {
        private ICustomTypeDescriptor _typeDescriptor;

        public CurrencyRateTypeDescriptorProvider() : base(TypeDescriptor.GetProvider(typeof (CurrencyRate)))
        {
        }

        public override ICustomTypeDescriptor GetTypeDescriptor(Type objectType, object instance)
        {
            return _typeDescriptor ?? (_typeDescriptor = new CurrencyRateTypeDescriptor(base.GetTypeDescriptor(objectType, instance)));
        }
    }
}